﻿#ifndef UIORGANIZATION_HPP
#define UIORGANIZATION_HPP

#include "UIListCommonDefine.hpp"

class CProfileWnd;

namespace DuiLib
{
struct OrganizationListItemInfo
{
	bool folder;
	bool empty;
	CDuiString id;
	CDuiString logo;
	CDuiString nick_name;
	CDuiString description;
};


class COrganizationTreeUI : public CListUI
{
public:
	enum {SCROLL_TIMERID = 10};

	COrganizationTreeUI(CPaintManagerUI& paint_manager, HWND hWnd);
	~COrganizationTreeUI();
	bool		Add(CControlUI* pControl);
	bool		AddAt(CControlUI* pControl, int iIndex);
	bool		Remove(CControlUI* pControl);
	bool		RemoveAt(int iIndex);
	void		RemoveAll();
	void		DoEvent(TEventUI& event);
	Node*		GetRoot();
	Node*		AddNode(const OrganizationListItemInfo& item, Node* parent = NULL, int nTopPadding = 0);
	bool		RemoveNode(Node* node);
	void		SetChildVisible(Node* node, bool visible);
	void		ExpandNode(Node* node, bool visible);
	bool		CanExpand(Node* node) const;
	IListItemUI*GetListItemUI(int nIndex); 
	/*bool		SelectItem(int iIndex, bool bTakeFocus = false);
	bool		SetSelectItem(int iIndex, bool bTakeFocus = false);
	bool		SelectItemNormal(int iIndex, bool bTakeFocus = false);
	bool		SelectItemCtrl(int iIndex, bool bTakeFocus = false);
	bool		SelectItemShift(int iIndex, bool bTakeFocus = false);*/
	void		ShowProfileWnd(const POINT &pt, CDuiString strID);
	void		RequestUserImage(LPCTSTR strID);
	int			GetNextSelectedItem(POSITION &pos);
	Node*		GetItemNode(int nIndex);
	void		OnMouseButtonEvent(int nTypeEvent, int nIndex);

	HWND		GetParentHwnd();
	std::vector<Node*> GetSelectedItems();
public:
	CPaintManagerUI& paint_manager_;
private:
	Node*	root_node_;
	LONG	delay_deltaY_;
	DWORD	delay_number_;
	DWORD	delay_left_;
	CDuiRect	text_padding_;
	CDuiString level_expand_image_;
	CDuiString level_collapse_image_;
    CDialogBuilder m_dlgBuilder;
	int		m_nShiftFirstSel;
	int		m_nShiftSecondSel;

	HWND		 m_hParent;
};

} // DuiLib

#endif // UIORGANIZATION_HPP